<?php
/*	sample_folder_page : Folder & page template module sample
	name : sample_folder_page
	author: team1/3
	
	Please replave sample_folder_page to your plugin name
	
*/

	global $params,$config;

	if (!isset($config)) { die(); }
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];
	
	if (PAGE_FOLDER_ID != $page_ar['type']) {
		if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
			// 編集
			provide_edit_module();
			unset($params['breadcrumb']);
			snippet_breadcrumb($p_page, 'Page Edit');
			$buff = page_edit_renderer($page_ar);
			$html['article'][] = frame_renderer($buff);
			return;
		}
		$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分
		$html['article'][] = innerpage_renderer($page_ar['id']);
		return;
	}

	if (check_rights('owner')) {
		//ページ作成者にはログインユーザーでも編集権限を与える
		set_func_right('edit.modules');
		set_func_right('add_page');
		provide_edit_rights();
		provide_edit_module();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && $_GET['mode']=='format') {
		// format編集
		$params['hook']['before_modified'][] = 'sample_folder_page_onbefore_modified';
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Format Edit');

		$params['hide-editmenu'] = true;
$params['add-editmenu'][] = <<<EOT
		<input type='button' onclick='ot.save_editdata(1)' class='onethird-button mini'  value='save' />
		<input type='button' onclick='ot.open_uploader({select:function(obj){ot.editor.insertimg(obj)}})' class='onethird-button mini' value='image' />
EOT;
		if (isset($page_ar['meta']['format'])) {
			$page_ar['contents'] = $page_ar['meta']['format'];
		} else {
			$page_ar['contents'] = '';
		}
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		sample_folder_page_menu($page_ar);
		$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分
		sample_folder_page_folder($page_ar);
		$html['article'][] = innerpage_renderer($page_ar['id']);
	}

	// css style
	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
			.plugin-page-folder-unit {
				margin-bottom:10px;
			}
			.plugin-page-folder-unit p {
				margin:0 0 5px 0;
				padding:0;
			}
			.plugin-page-folder-unit .title {
				color: #286593;
				font-size: 20px;
				margin:0 0 5px 0;
			}
			.plugin-page-folder-unit .onethird-button {
				margin-top:10px;
			}
			.plugin-page-folder-unit .add-panel {
				margin:15px 0 15px 0;
			}
			.plugin-page-folder-unit img {
				vertical-align: middle;
			}
			.plugin-page-folder-unit p .date {
				color:#A0A0A0;
				font-size:90%;
			}
			.plugin-page-folder-unit p .new {
				color:#FF7000;
				padding:0 5px;
			}
		</style>
EOT;
	}

}

function sample_folder_page_onbefore_modified( &$new_ar )
{
	global $params,$config,$ut;

	if (isset($_GET['mode']) && $_GET['mode'] != 'format') {
		return;
	}
	
	//フォーマットの保存処理
	$new_ar['meta']['format'] = $new_ar['contents'];
	$new_ar['metadata'] = serialize64($new_ar['meta']);
	unset($new_ar['meta']);
	unset($new_ar['contents']);
	if (!mod_data_items($new_ar)) {
		if (isset($_POST['ajax'])) {
			echo( json_encode($r) );
			exit();
		}
		exit_proc(400, 'Save-Error');

	} else {

		if ($new_ar['type'] >= 10) {
			event_plugin_page('onmodified', $new_ar);
		}
		
		if (isset($r['url'])) {
			header("Location: {$r['url']}");
		
		} else {
			if ($new_ar['block_type'] == 5) {
				header("Location: {$ut->link($new_ar['link'])}");
			} else {
				header("Location: {$ut->link($new_ar['id'])}");
			}
		}
		
		exit();
	}
}

function sample_folder_page_menu( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];
	$parent_page = $page_ar['id'];		//自ページが親ページ

	$allow_post = !empty($page_ar['meta']['page_folder_allow_post']) && check_rights();

	if ($allow_post) {
		set_func_right('add_data_items');
		provide_edit_rights();
	}

	if ($allow_post || isset($params['edit-right']) || check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_sample_folder_page_make_page')  {
			$r = array();
			$r['link'] = (int)$_POST['page'];
			$r['result'] = false;
			
			if (empty($_POST['type'])) {
				echo( json_encode($r) );
				exit();
			}
			$r['type'] = (int)($_POST['type']);
			if ($r['type'] == PAGE_FOLDER_ID) {
				$r['title'] = 'Folder'.time();
				$r['block_type'] = 1;
				if (isset($page_ar['meta']['format'])) {
					$r['meta']['format'] = $page_ar['meta']['format'];
				}
				if ($allow_post) {
					$r['meta']['page_folder_allow_post'] = true;
				}
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
				$r['meta']['lwr_template_ar']['php'] = ".".basename(__FILE__);
			} else {
				$r['title'] = 'page'.time();
				$r['block_type'] = 1;
				if (isset($page_ar['meta']['format'])) {
					$r['contents'] = $page_ar['meta']['format'];
				}
				$r['meta']['template_ar']['php'] = ".".basename(__FILE__);
			}
			create_page( $r );
			
			if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
				unset($r['open_url']);
			}
			echo( json_encode($r) );
			exit();
		}
		if (!isset($html['meta']['plugin_sample_folder_page_make_page'])) {
$html['meta']['plugin_sample_folder_page_make_page'] = <<<EOT
			<script>
			ot.plugin_sample_folder_page_make_page = function (link,type) {
				var opt = "ajax=plugin_sample_folder_page_make_page";
				opt += "&type="+type+"&page="+link;
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if ( data['open_url'] ) {
								location.href = data['open_url'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

$params['add-blockmenu'][] = <<<EOT
	<a href='{$ut->link($page_ar['id'],'&:mode=format')}' class='onethird-button mini'>format</a>
	<a href='javascript:void(ot.page_folder_setting())' class='onethird-button mini'>Setting</a>
EOT;

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","page_folder_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_folder_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $p_id = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];
$r['html'] = <<<EOT
			<table>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label>
								<input type='checkbox' data-input='page_folder_allow_post' 
									{$ut->check(!empty($r['meta']['page_folder_allow_post']),'checked')}/> 
									Allow All Users to Submit Posts
								</label>
							</li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_folder_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];
			$r['meta']['acc_ctrl'] = array();
			if (isset($_POST['page_folder_allow_post'])) {
				$r['meta']['page_folder_allow_post'] = true;
			} else {
				$r['meta']['page_folder_allow_post'] = false;
			}
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}
	}

}

function sample_folder_page_folder( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];

	$add_type = 1;
	$folder_type = PAGE_FOLDER_ID;
	
	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = 7;

	$offset_name = 'offset';
	$option['offset_name'] = $offset_name;
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}
	

	$sql = array();
	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	$sql[1] = array(" where link=? and block_type !=5",$id);
	$sql[2] = array(" and type=? and type <> ?",$add_type,PAGE_FOLDER_ID);

	if (check_rights()) {
		$sql[3] = array(' and (mode=1 or (mode=0 and user=?)) ',(int)($_SESSION['login_id']));
	} else {
		$sql[3] = array(' and mode=1 ');
	}

	// count
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}

	// foloder
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[2] = array(" and type=?",PAGE_FOLDER_ID);
	$sql[4] = array("order by date desc");
	$folder_ar = $database->sql_select_all($sql);

	// page
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[2] = array(" and type=? and type <> ?",$add_type,PAGE_FOLDER_ID);
	$sql[5]  = array(" {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ");
	
	$ar = $database->sql_select_all($sql);

	$buff = '';
	if ($folder_ar) {
		$ar = array_merge($folder_ar,$ar);
	}
	$buff .= std_pagination_renderer( $option );
	$nt = time();
	if ($ar) {
		foreach ($ar as $v) {
			$t = $v['title'];
			$ico = '';
			if (!$t) { $t = '...'; }
			$u = $ut->link($v['id']);
			if ($v['type'] == PAGE_FOLDER_ID) {
				$ico = $ut->icon('folder',"width='16'");
			}
			if ($v['mode'] == 0) {
				$t = $t.$ut->icon('lock','width="16"');
			}
			$d = substr($v['date'],0,10);
$buff .= <<<EOT
			<p id='plugin_page_folder{$v['id']}' >
				{$ico} <a href='{$ut->link($v['id'])}'>{$t}</a> <span class='date'>{$d}</span>
			</p>
EOT;
		}
	}
	
	if (check_func_right('add_data_items') || check_rights('edit')) {
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='Add page' class='onethird-button mini' onclick='ot.plugin_sample_folder_page_make_page({$id}, $add_type)' />
			<input type='button' value='Add folder' class='onethird-button mini' onclick='ot.plugin_sample_folder_page_make_page({$id}, $folder_type)' />
		</p>
EOT;
	}

	$html['article'][] = frame_renderer($buff,'plugin-page-folder-unit');
}


?>